Save PDF Files in JavaScript (ES5) PDF Viewer

17 Aug 20266 minutes to read

After annotating or editing a document, use the JavaScript PDF Viewer component to persist the updated PDF to a server, local storage, or a database.

Save a PDF file to a server

Follow these steps to upload the modified document to a server-side location.

Step 1: Create a JavaScript PDF Viewer sample

Follow the getting started guide to configure a JavaScript PDF Viewer project. This provides the viewer instance required to submit downloads to a web service.

Step 2: Modify the PdfViewerController.cs file in the web service project

  1. Create a web service in .NET Core 3.0 or later. Refer to How to create PDF Viewer web service in .NET Core 3.0 and above for detailed instructions.
  2. Open the PdfViewerController.cs file in the service project.
  3. Update the Download action to save the output file on the server.
public IActionResult Download([FromBody] Dictionary<string, string> jsonObject)
{
  //Initialize the PDF Viewer object with memory cache object
  PdfRenderer pdfviewer = new PdfRenderer(_cache);
  string documentBase = pdfviewer.GetDocumentAsBase64(jsonObject);
  MemoryStream stream = new MemoryStream();

  string documentName = jsonObject["document"];
  string result = Path.GetFileNameWithoutExtension(documentName);
  string fileName = result + "_downloaded.pdf";

  // Save the file on the server
  string serverFilePath = @"Path to where you need to save your file in the server";

  string filePath = Path.Combine(serverFilePath, fileName);

  using (FileStream fileStream = new FileStream(filePath, FileMode.Create))
  {
    //Saving the new file in root path of application
    stream.CopyTo(fileStream);
    fileStream.Close();
  }
  return Content(documentBase);
}

NOTE

Ensure the application pool identity or service account has write access to the destination directory before saving files.

Step 3: Set PDF Viewer service properties

Specify the serviceUrl of your web service and the document to load.

import { PdfViewer, Toolbar, Magnification, Navigation, LinkAnnotation,ThumbnailView,
         BookmarkView, TextSelection, Annotation, FormFields, FormDesigner} from '@syncfusion/ej2-pdfviewer';

PdfViewer.Inject( Toolbar,Magnification,Navigation, LinkAnnotation,ThumbnailView,
                  BookmarkView, TextSelection, Annotation, FormFields, FormDesigner);

let viewer: PdfViewer = new PdfViewer();
// Replace PDF_Succinctly.pdf with the actual document name that you want to load
viewer.documentPath="PDF_Succinctly.pdf"
viewer.serviceUrl = 'https://localhost:44396/pdfviewer';
viewer.appendTo('#pdfViewer');

NOTE

Replace the placeholder service URL and document name with your deployment values. Configure CORS on the web service if the viewer runs on a different origin.

View sample in GitHub

Download a PDF file as a copy

The built-in toolbar includes a Download button that saves the current PDF to the local file system. You can also trigger the same behavior from custom UI by calling download.

<button id="download">Download</button>
document.getElementById('download').addEventListener('click', function () {
  //API to perform download action.
  viewer.download();
});

NOTE

The download method returns the document after applying annotations, form edits, and other runtime changes.

Save a PDF file to a database

Use the following steps to persist the generated PDF document to a SQL Server database.

Step 1: Create a JavaScript PDF Viewer sample

Follow the getting started guide to configure a JavaScript PDF Viewer project.

Step 2: Modify the PdfViewerController.cs file in the web service project

  1. Create a web service in .NET Core 3.0 or later.
  2. Open the PdfViewerController.cs file.
  3. Import the required namespaces at the top of the file.
using System.IO;
using System.Data.SqlClient;
  1. Add the following private fields and constructor parameters to the PdfViewerController class, and map configuration values in the constructor.
private IConfiguration _configuration;
public readonly string _connectionString;

public PdfViewerController(IWebHostEnvironment hostingEnvironment, IMemoryCache cache, IConfiguration configuration)
{
  _hostingEnvironment = hostingEnvironment;
  _cache = cache;
  _configuration = configuration;
  _connectionString = _configuration.GetValue<string>("ConnectionString");
}
  1. Update the Download action to insert the document into a database table.
[HttpPost("Download")]
[Microsoft.AspNetCore.Cors.EnableCors("MyPolicy")]
[Route("[controller]/Download")]
//Post action for downloading the PDF documents

public async Task<IActionResult> Download([FromBody] Dictionary<string, string> jsonObject)
{
  //Initialize the PDF Viewer object with memory cache object
  PdfRenderer pdfviewer = new PdfRenderer(_cache);

  string documentBase = pdfviewer.GetDocumentAsBase64(jsonObject);
  byte[] documentBytes = Convert.FromBase64String(documentBase.Split(",")[1]);

  string documentId = jsonObject["documentId"];
  string result = Path.GetFileNameWithoutExtension(documentId);
  string fileName = result + "_downloaded.pdf";

  string connectionString = _connectionString;

  using (SqlConnection connection = new SqlConnection(connectionString))
  {
    connection.Open();

    using (SqlCommand cmd = new SqlCommand("INSERT INTO Table (FileName, fileData) VALUES (@FileName, @fileData)", connection))
    {
      cmd.Parameters.AddWithValue("@FileName", fileName);
      cmd.Parameters.AddWithValue("@fileData", documentBytes);

      cmd.ExecuteNonQuery();
    }
    connection.Close();
  }
  return Content(documentBase);
}
  1. Update the appsettings.json file to include the connection string setting.
{
  "Logging": {
    "LogLevel": {
      "Default": "Information",
      "Microsoft.AspNetCore": "Warning"
    }
  },
  "AllowedHosts": "*",
  "ConnectionString": "Your connection string for SQL server"
}

NOTE

Replace Your connection string for SQL server with the actual value. Make sure the database table, columns, and permissions exist before inserting records.

NOTE

Install the System.Data.SqlClient package in the application to execute SQL commands with the previous example. Update the connection string to match your environment.

View sample in GitHub

Save PDF Files in Angular PDF Viewer

14 Aug 20264 minutes to read

After annotating a PDF with the viewer’s annotation tools, save the updated file to a server, database, or local file system so changes persist.

Save PDF file to Server

To save a modified PDF to a server, follow these steps.

Step 1: Create a Simple PDF Viewer Sample in Angular

Follow the getting-started guide at Link to create a basic Angular PDF viewer sample. This provides the client-side setup for annotation and saving.

Step 2: Modify the PdfViewerController.cs File in the Web Service Project

  1. Create a web service project in .NET Core 3.0 or above. See this for a reference implementation.

  2. Open the PdfViewerController.cs file in the web service project.

  3. Modify the Download() method to open it in the viewer using URL

public IActionResult Download([FromBody] Dictionary<string, string> jsonObject)
{
  //Initialize the PDF Viewer object with memory cache object
  PdfRenderer pdfviewer = new PdfRenderer(_cache);
  string documentBase = pdfviewer.GetDocumentAsBase64(jsonObject);
  MemoryStream stream = new MemoryStream();

  string documentName = jsonObject["document"];
  string result = Path.GetFileNameWithoutExtension(documentName);
  string fileName = result + "_downloaded.pdf";

  // Save the file on the server
  string serverFilePath = @"Path to where you need to save your file in the server";

  string filePath = Path.Combine(serverFilePath, fileName);

  using (FileStream fileStream = new FileStream(filePath, FileMode.Create))
  {
    //Saving the new file in root path of application
    stream.CopyTo(fileStream);
    fileStream.Close();
  }
  return Content(documentBase);
}

Step 3: Set the PDF Viewer Properties in Angular PDF viewer component

Modify the serviceUrl property of the PDF viewer component with the accurate URL of your web service project, replacing https://localhost:44396/pdfviewer with the actual URL of your server. Modify the documentPath with the correct PDF document URL to load.

import { Component, OnInit } from '@angular/core';
import { LinkAnnotationService, BookmarkViewService, MagnificationService,
         ThumbnailViewService, ToolbarService, NavigationService,
         TextSearchService, AnnotationService, TextSelectionService,
         PrintService, FormDesignerService, FormFieldsService} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-container',
  // specifies the template string for the PDF Viewer component
  template: `<div class="content-wrapper">
                  <ejs-pdfviewer id="pdfViewer"
                                [serviceUrl]='service'
                                [documentPath]='documentPath'
                                style="height:640px;display:block">
                  </ejs-pdfviewer>
            </div>`,
  providers: [ LinkAnnotationService, BookmarkViewService, MagnificationService,ThumbnailViewService,
               ToolbarService, NavigationService, AnnotationService, TextSearchService,
                TextSelectionService, PrintService, FormDesignerService, FormFieldsService]
   })
  export class AppComponent implements OnInit {
    // Replace the "localhost:44396" with the actual URL of your server
    public service = 'https://localhost:44396/pdfviewer';
    // Replace correct PDF Document URL want to load
    public documentPath="PDF_Succinctly.pdf"
  }

View sample in GitHub

Download PDF file as a copy

In the built-in toolbar, you have an option to download the updated PDF to the local file system, you can use it to download the PDF file.

<button (click)="downloadClicked()">Download</button>
downloadClicked() {
  var viewer = (<any>document.getElementById("pdfViewer")).ej2_instances[0];
  viewer.download();
}

Save PDF Files in React PDF Viewer

14 Aug 202617 minutes to read

After editing a PDF with annotation tools, you can save the updated file to a server, a database, or download it locally. The following sections show common approaches.

Save and Download the Edited PDF

After editing the PDF document, follow this short, linear flow to persist and retrieve the updated file:

  1. Persist the edited document to your back end (server or database). See “Save modified PDF to server” and “Save modified PDF to a database” below for server-side examples.
  2. Provide the updated file to the user. For a simple download use the built-in toolbar or call the viewer API download().
  3. If you need the edited PDF for custom uploads or processing, use the viewer saveAsBlob() API to obtain a Blob (or convert it to Base64).

This is a summary; use the detailed subsections below for full code samples and server-side instructions.

Save modified PDF to server

To save the modified PDF back to a server, follow these steps.

Step 1: Create a simple PDF Viewer sample in React

Follow the getting-started guide to create a basic PDF Viewer implementation.

Step 2: Modify the PdfViewerController.cs in the web service project

  1. Create a web service project targeting .NET Core 3.0 or later. See this KB Link for details.

  2. Open the PdfViewerController.cs file in your web service project.

  3. Modify the Download() method so it returns the modified document for the viewer to download or store.

public IActionResult Download([FromBody] Dictionary<string, string> jsonObject)
{
  //Initialize the PDF Viewer object with memory cache object
  PdfRenderer pdfviewer = new PdfRenderer(_cache);
  string documentBase = pdfviewer.GetDocumentAsBase64(jsonObject);
  MemoryStream stream = new MemoryStream();

  string documentName = jsonObject["document"];
  string result = Path.GetFileNameWithoutExtension(documentName);
  string fileName = result + "_downloaded.pdf";

  // Save the file on the server
  string serverFilePath = @"Path to where you need to save your file in the server";

  string filePath = Path.Combine(serverFilePath, fileName);

  using (FileStream fileStream = new FileStream(filePath, FileMode.Create))
  {
    //Saving the new file in root path of application
    stream.CopyTo(fileStream);
    fileStream.Close();
  }
  return Content(documentBase);
}

Step 3: Set the PDF Viewer properties in your React app

Set the serviceUrl to point to your web service (for example, replace https://localhost:44396/pdfviewer with your server URL). Also set documentPath to the document URL you want to load.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { PdfViewerComponent, Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView, ThumbnailView,
         Print, TextSelection, Annotation, TextSearch, Inject, FormDesigner, FormFields} from '@syncfusion/ej2-react-pdfviewer';

function App() {
  return (<div>
    <div className='control-section'>
      {/* Render the PDF Viewer */}
        <PdfViewerComponent
          id="container"
          // Replace with the correct PDF document URL you want to load
          documentPath="https://cdn.syncfusion.com/content/PDFViewer/flutter-succinctly.pdf"
          serviceUrl="https://localhost:44396/pdfviewer"
          style={{ 'height': '640px' }}>

              <Inject services={[ Toolbar, Magnification, Navigation, Annotation, LinkAnnotation, BookmarkView, ThumbnailView,
                                  Print, TextSelection, TextSearch, FormDesigner, FormFields ]} />

        </PdfViewerComponent>
    </div>
  </div>);
}
const root = ReactDOM.createRoot(document.getElementById('sample'));
root.render(<App />);

View sample in GitHub

Download PDF file as a copy

The built-in toolbar includes a download option that saves the updated PDF to the user’s local file system. You can also trigger the same behavior programmatically by calling the viewer’s download() API.

import * as ReactDOM from 'react-dom/client';
import * as React from 'react';
import './index.css';
import { PdfViewerComponent, Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView,
         ThumbnailView, Print, TextSelection, Annotation, TextSearch, FormFields, FormDesigner, Inject} from '@syncfusion/ej2-react-pdfviewer';

export function App() {

  function downloadClicked() {
    var viewer = document.getElementById('container').ej2_instances[0];
    viewer.download();
  }

return (<div>
    <div className='control-section'>
    <button onClick={downloadClicked}>Download</button>
        <PdfViewerComponent
          id="container"
          // Replace PDF_Succinctly.pdf with the actual document name that you want to load
          documentPath="PDF_Succinctly.pdf"
          // Replace the "localhost:44396" with the actual URL of your server
          serviceUrl="https://localhost:44396/pdfviewer"
          style={{ 'height': '640px' }}>

              {/* Inject the required services */}
              <Inject services={[ Toolbar, Magnification, Navigation, Annotation, LinkAnnotation, BookmarkView,
                                  ThumbnailView, Print, TextSelection, TextSearch, FormFields, FormDesigner]} />
        </PdfViewerComponent>
    </div>
</div>);
}
const root = ReactDOM.createRoot(document.getElementById('sample'));
root.render(<App />);

Save modified PDF to a database

If your application stores PDF files in a database, you can save the updated PDF bytes back to the database from your web service. The following steps outline a typical server-side flow.

Step 1: Create the React sample viewer

Follow the getting-started guide to set up a basic Viewer instance.

Step 2: Update PdfViewerController.cs in the web service

  1. Create a web service project targeting .NET Core 3.0 or later (see the KB link above). Open the PdfViewerController.cs file in your web service project.

  2. Import required namespaces:

using System.IO;
using System.Data.SqlClient;
  1. Add configuration fields to your controller and read the connection string from configuration:
private IConfiguration _configuration;
public readonly string _connectionString;

public PdfViewerController(IWebHostEnvironment hostingEnvironment, IMemoryCache cache, IConfiguration configuration)
{
  _hostingEnvironment = hostingEnvironment;
  _cache = cache;
  _configuration = configuration;
  _connectionString = _configuration.GetValue<string>("ConnectionString");
}
  1. In the Download() method, convert the returned base64 document to bytes and insert it into your database (the example below uses parameterized commands to avoid SQL injection):
[HttpPost("Download")]
[Microsoft.AspNetCore.Cors.EnableCors("MyPolicy")]
[Route("[controller]/Download")]
public async Task<IActionResult> Download([FromBody] Dictionary<string, string> jsonObject)
{
  //Initialize the PDF Viewer object with memory cache object
  PdfRenderer pdfviewer = new PdfRenderer(_cache);

  string documentBase = pdfviewer.GetDocumentAsBase64(jsonObject);
  byte[] documentBytes = Convert.FromBase64String(documentBase.Split(",")[1]);

  string documentId = jsonObject["documentId"];
  string result = Path.GetFileNameWithoutExtension(documentId);
  string fileName = result + "_downloaded.pdf";

  string connectionString = _connectionString;

  using (SqlConnection connection = new SqlConnection(connectionString))
  {
    connection.Open();

    using (SqlCommand cmd = new SqlCommand("INSERT INTO Table (FileName, fileData) VALUES (@FileName, @fileData)", connection))
    {
      cmd.Parameters.AddWithValue("@FileName", fileName);
      cmd.Parameters.AddWithValue("@fileData", documentBytes);

      cmd.ExecuteNonQuery();
    }
    connection.Close();
  }
  return Content(documentBase);
}
  1. Add the connection string to appsettings.json:
{
  "Logging": {
    "LogLevel": {
      "Default": "Information",
      "Microsoft.AspNetCore": "Warning"
    }
  },
  "AllowedHosts": "*",
  "ConnectionString": "Your connection string for SQL Server"
}

NOTE

Replace Your connection string for SQL Server with your actual connection string.

NOTE

Ensure the System.Data.SqlClient package (or Microsoft.Data.SqlClient) is installed in your project. Use parameterized queries (as shown) and validate inputs to avoid SQL injection risks.

View sample in GitHub

Save to Cloud Storage Services

Each link below goes to a provider page with simple, step-by-step instructions and example code for saving the edited PDF to that cloud storage service.

Save PDF with or without annotations

The React PDF Viewer allows exporting the current PDF along with annotations, or exporting a clean version without annotations. This gives flexibility depending on workflow review mode, sharing, or securing final documents.

Save PDF with annotations

The PDF is exported with annotations and form fields by default. You can download a PDF using the download button in the built‑in toolbar or through the download API. See the download guide for further explanation.

Save PDF without annotations

The PDF can be exported without annotations by setting the skipDownload API to true in annotationSettings.

  • TS
  • <PdfViewerComponent
        id="pdfViewer"
        documentPath="https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf"
        resourceUrl="https://cdn.syncfusion.com/ej2/32.2.5/dist/ej2-pdfviewer-lib"
        annotationSettings={{
            skipDownload: true
        }}
    >
        <Inject services={[Toolbar, Magnification, Navigation, Annotation, LinkAnnotation, ThumbnailView,
            BookmarkView, TextSelection, TextSearch, FormFields, FormDesigner, PageOrganizer, Print]} />
    </PdfViewerComponent>

    Save after restoring annotations

    PDFs can also be exported after importing annotations. The following code example uses the downloadStart event to cancel the download action and import the annotations from a JSON file before downloading the PDF document.

    import {
        PdfViewerComponent, Toolbar, Magnification, Navigation, Annotation, LinkAnnotation,
        ThumbnailView, BookmarkView, TextSelection, TextSearch, FormFields, FormDesigner,
        PageOrganizer, Inject, Print, DownloadStartEventArgs
    } from '@syncfusion/ej2-react-pdfviewer';
    import { DataFormat, PdfDocument } from '@syncfusion/ej2-pdf';
    import { RefObject, useRef } from 'react';
    
    export default function App() {
        const viewerRef: RefObject<PdfViewerComponent> = useRef(null);
    
        const blobToBase64 = async (blob: Blob): Promise<string> => {
            return new Promise((resolve, reject) => {
                const reader = new FileReader();
                reader.onerror = () => reject(reader.error);
                reader.onload = () => {
                    const dataUrl: string = reader.result as string;
                    const data: string = dataUrl.split(',')[1];
                    resolve(data);
                };
                reader.readAsDataURL(blob);
            });
        }
    
        const restoreAnnotations = async (data: string) => {
            try {            
                const fetchResponse: Response = await fetch("/pdf-succinctly.json", { headers: { Accept: "application/json" } });
                if (fetchResponse.ok) {
                    let document: PdfDocument = new PdfDocument(data);
                    let jsonData = await fetchResponse.json();
                    document.importAnnotations(btoa(JSON.stringify(jsonData)), DataFormat.json);
                    document.save(`${viewerRef.current.fileName}.pdf`);
                    document.destroy();
                }
                else {
                    throw new Error(`HTTP ${fetchResponse.status}`);
                }            
            }
            catch (error) {
                console.error(error);
            }
        }
    
        const handleImports = async () => {
            const blob: Blob = await viewerRef.current.saveAsBlob();
            const data: string = await blobToBase64(blob);
            await restoreAnnotations(data);
        }
    
        const onDownloadStart = async (args: DownloadStartEventArgs) => {
            args.cancel = true;
            await handleImports();
        };
    
        return (
            <div style={{ height: '640px' }}>
                <PdfViewerComponent
                    id="pdf-viewer"
                    ref={viewerRef}
                    documentPath="https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf"
                    resourceUrl="https://cdn.syncfusion.com/ej2/32.2.5/dist/ej2-pdfviewer-lib"
                    downloadStart={onDownloadStart}
                >
                    <Inject services={[Toolbar, Magnification, Navigation, Annotation, LinkAnnotation, ThumbnailView,
                        BookmarkView, TextSelection, TextSearch, FormFields, FormDesigner, PageOrganizer, Print]} />
                </PdfViewerComponent>
            </div>
        );
    }

    See also

Save PDF Files in Vue PDF Viewer

14 Aug 202611 minutes to read

After annotating or editing a PDF document in the Vue PDF Viewer component, save the updated file to a server, database, or the local file system using the approaches outlined in this guide.

Prerequisites

Saving and downloading operations require server-side processing. Before implementing any save workflow:

  • Configure a server-backed PDF Viewer web service (see Web Service Setup Guide)
  • Ensure the Vue PDF Viewer is configured with the serviceUrl property pointing to your web service
  • Have appropriate file access permissions on your target storage location (server filesystem or database)

Save PDF Files in Vue PDF Viewer to server storage

This approach persists edited PDF files back to your server’s filesystem, making them available for retrieval and further processing.

Step 1: Set up the Vue PDF Viewer component

Follow the Getting started with server-backed PDF Viewer guide to create a Vue application with the PDF Viewer component and configure the serviceUrl property.

Step 2: Modify the server web service

Configure your .NET Core web service to save edited PDFs to server storage:

  1. Create a web service project in .NET Core 3.0 or later by following the Web Service Setup Guide.

  2. Open the PdfViewerController.cs file and modify the Download() method to save the updated PDF to your server.

  3. Update the serverFilePath variable with the absolute path to your target folder. Ensure the application has write permissions to this location.

public IActionResult Download([FromBody] Dictionary<string, string> jsonObject)
{
  //Initialize the PDF Viewer object with memory cache object
  PdfRenderer pdfviewer = new PdfRenderer(_cache);
  string documentBase = pdfviewer.GetDocumentAsBase64(jsonObject);
  MemoryStream stream = new MemoryStream();

  string documentName = jsonObject["document"];
  string result = Path.GetFileNameWithoutExtension(documentName);
  string fileName = result + "_downloaded.pdf";

  // Save the file on the server
  string serverFilePath = @"Path to where you need to save your file in the server";

  string filePath = Path.Combine(serverFilePath, fileName);

  using (FileStream fileStream = new FileStream(filePath, FileMode.Create))
  {
    //Saving the new file in root path of application
    stream.CopyTo(fileStream);
    fileStream.Close();
  }
  return Content(documentBase);
}

Step 3: Configure the Vue PDF Viewer component

Configure the PDF Viewer component with your web service URL:

<template>
  <div id="app">
    <ejs-pdfviewer id="pdfViewer" :serviceUrl="serviceUrl" :documentPath="documentPath">
    </ejs-pdfviewer>
  </div>
</template>

<script setup>
import { provide } from "vue";
import {
  PdfViewerComponent as EjsPdfviewer, Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView,
  ThumbnailView, Print, TextSelection, TextSearch, Annotation, FormFields, FormDesigner
} from '@syncfusion/ej2-vue-pdfviewer';

// Replace with your web service URL
const serviceUrl = "https://localhost:44396/pdfviewer";
const documentPath = "https://cdn.syncfusion.com/content/PDFViewer/flutter-succinctly.pdf";

provide('PdfViewer', [Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView, ThumbnailView,
  Print, TextSelection, TextSearch, Annotation, FormFields, FormDesigner]);

</script>
<template>
  <div id="app">
    <ejs-pdfviewer id="pdfViewer" :serviceUrl="serviceUrl" :documentPath="documentPath">
    </ejs-pdfviewer>
  </div>
</template>

<script>
import {
  PdfViewerComponent, Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView,
  ThumbnailView, Print, TextSelection, TextSearch, Annotation, FormFields, FormDesigner
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  name: 'app',
  components: {
    'ejs-pdfviewer': PdfViewerComponent
  },
  data() {
    return {
      // Replace with your web service URL
      serviceUrl: "https://localhost:44396/pdfviewer",
      documentPath: "https://cdn.syncfusion.com/content/PDFViewer/flutter-succinctly.pdf"
    };
  },
  provide: {
    PdfViewer: [Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView, ThumbnailView,
      Print, TextSelection, TextSearch, Annotation, FormFields, FormDesigner]
  }
}
</script>

View sample in GitHub

Download PDF to local file system

Export the edited PDF as a local copy to the user’s device using the built-in download functionality or a custom button. This approach does not store the file on the server.

<template>
  <div id="app">
    <button v-on:click="downloadClicked">Download</button>
    <ejs-pdfviewer id="pdfViewer" ref="pdfviewer" :serviceUrl="serviceUrl" :documentPath="documentPath">
    </ejs-pdfviewer>
  </div>
</template>

<script setup>
import { provide, ref } from "vue";
import {
  PdfViewerComponent as EjsPdfviewer, Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView,
  ThumbnailView, Print, TextSelection, TextSearch, Annotation, FormFields, FormDesigner
} from '@syncfusion/ej2-vue-pdfviewer';

const pdfviewer = ref(null);
// Replace the "localhost:44396" with the actual URL of your server
const serviceUrl = "https://localhost:44396/pdfviewer";
// Replace PDF_Succinctly.pdf with the actual document name that you want to load
const documentPath = "PDF_Succinctly.pdf"

provide('PdfViewer', [Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView, ThumbnailView,
  Print, TextSelection, TextSearch, Annotation, FormFields, FormDesigner]);,

const downloadClicked = function (args) {
  pdfviewer.value.ej2Instances.download();
}
</script>
<template>
  <div id="app">
    <button v-on:click="downloadClicked">Download</button>
    <ejs-pdfviewer id="pdfViewer" :serviceUrl="serviceUrl" :documentPath="documentPath">
    </ejs-pdfviewer>
  </div>
</template>

<script>
import {
  PdfViewerComponent, Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView,
  ThumbnailView, Print, TextSelection, TextSearch, Annotation, FormFields, FormDesigner
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  name: 'app',
  components: {
    'ejs-pdfviewer': PdfViewerComponent
  },
  data() {
    return {
      // Replace the "localhost:44396" with the actual URL of your server
      serviceUrl: "https://localhost:44396/pdfviewer",
      // Replace PDF_Succinctly.pdf with the actual document name that you want to load
      documentPath: "PDF_Succinctly.pdf"

    };
  },
  provide: {
    PdfViewer: [Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView, ThumbnailView,
      Print, TextSelection, TextSearch, Annotation, FormFields, FormDesigner]
  },
  methods: {
    downloadClicked: function (args) {
      this.$refs.pdfviewer.ej2Instances.download();
    },
  }
}
</script>

When using a custom download button, ensure the PDF Viewer component has a ref assigned so the handler can access the ej2Instances.download() method.

Save PDF Files in Vue PDF Viewer to database

Use this approach when you need to store edited PDFs in a database for versioning, archival, or complex query scenarios.

Step 1: Set up the Vue PDF Viewer component

Follow the Getting started with server-backed PDF Viewer guide to create a Vue application with the PDF Viewer component.

Step 2: Configure the server web service to save to database

  1. Create a web service project in .NET Core 3.0 or later (see Web Service Setup Guide).

  2. Open the PdfViewerController.cs file and add the required namespaces:

using System.IO;
using System.Data.SqlClient;
  1. Add configuration properties to the PdfViewerController class:
private IConfiguration _configuration;
public readonly string _connectionString;

public PdfViewerController(IWebHostEnvironment hostingEnvironment, IMemoryCache cache, IConfiguration configuration)
{
  _hostingEnvironment = hostingEnvironment;
  _cache = cache;
  _configuration = configuration;
  _connectionString = _configuration.GetValue<string>("ConnectionString");
}
  1. Modify the Download() method to save the PDF to the database. Adjust the SQL command and table/column names to match your database schema:
[HttpPost("Download")]
[Microsoft.AspNetCore.Cors.EnableCors("MyPolicy")]
[Route("[controller]/Download")]
//Post action for downloading the PDF documents

public async Task<IActionResult> Download([FromBody] Dictionary<string, string> jsonObject)
{
  //Initialize the PDF Viewer object with memory cache object
  PdfRenderer pdfviewer = new PdfRenderer(_cache);

  string documentBase = pdfviewer.GetDocumentAsBase64(jsonObject);
  byte[] documentBytes = Convert.FromBase64String(documentBase.Split(",")[1]);

  string documentId = jsonObject["documentId"];
  string result = Path.GetFileNameWithoutExtension(documentId);
  string fileName = result + "_downloaded.pdf";

  string connectionString = _connectionString;

  using (SqlConnection connection = new SqlConnection(connectionString))
  {
    connection.Open();

    using (SqlCommand cmd = new SqlCommand("INSERT INTO Table (FileName, fileData) VALUES (@FileName, @fileData)", connection))
    {
      cmd.Parameters.AddWithValue("@FileName", fileName);
      cmd.Parameters.AddWithValue("@fileData", documentBytes);

      cmd.ExecuteNonQuery();
    }
    connection.Close();
  }
  return Content(documentBase);
}
  1. Configure the database connection in your appsettings.json file:
{
  "Logging": {
    "LogLevel": {
      "Default": "Information",
      "Microsoft.AspNetCore": "Warning"
    }
  },
  "AllowedHosts": "*",
  "ConnectionString": "Your connection string for SQL server"
}

Before running this example:

  • Install the System.Data.SqlClient NuGet package in your web service project
  • Update the connection string in appsettings.json with your SQL Server credentials
  • Create the database table using the SQL script provided
  • Ensure the application has read/write permissions to the database

View sample in GitHub